/**
 *  @author     TTF006
 *  @version    $Id: $
 *  @desc       This module provides offline mode of test adapter for VxLTE.
 *  @see        
 */
package com.iskratel.ttcn.tri;

import org.apache.log4j.Logger;
import org.etsi.ttcn.tri.TriAddress;
import org.etsi.ttcn.tri.TriCommunicationTE;
import org.etsi.ttcn.tri.TriComponentId;
import org.etsi.ttcn.tri.TriMessage;
import org.etsi.ttcn.tri.TriPortId;
import org.etsi.ttcn.tri.TriStatus;

import com.testingtech.ttcn.tri.TriAddressImpl;
import com.testingtech.ttcn.tri.TriMessageImpl;
import com.testingtech.ttcn.tri.TriStatusImpl;

import jpcap.packet.Packet;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class IotConnectionOffline extends Thread/* PCAP */ implements LocalAdapterBase {

	TriCommunicationTE cte = null;
	TriPortId comPortId = null;
	TriPortId tsiPortId = null;

	Logger log = null;

	public static Hashtable<String, TriPortId> ComponentCollection = new Hashtable<String, TriPortId>();
	public static Hashtable<String, TriPortId> ComponentCollectionCompPort = new Hashtable<String, TriPortId>();
	public static Hashtable<String, FilterPackets> ComponentCollectionFilter2Port = new Hashtable<String, FilterPackets>();

	private Queue<TriComponentId> FilterMsgFIFO = new LinkedList<>(); // for selection sequence to which PTC first send
																		// resonse

	public String tracefile = "";

	public class FilterPackets {
		public List packets;
		public String filter;
		public TriComponentId componentId;
		public TriPortId tsiPortId;
		public TriCommunicationTE cte;
		final IotConnectionOffline this$0;

		public boolean equals(Object obj) {
			if (obj instanceof FilterPackets) {
				return filter.equals(((FilterPackets) obj).filter);
			} else {
				return false;
			}
		}

		public int hashCode() {
			return filter.hashCode() + componentId.hashCode();
		}

		public FilterPackets(String filter) {
			super();
			this$0 = IotConnectionOffline.this;
			this.filter = filter;
		}

		public FilterPackets(String filter, TriComponentId componentId, TriPortId tsiPortId, TriCommunicationTE cte) {
			this(filter);
			this.componentId = componentId;
			this.tsiPortId = tsiPortId;
			this.cte = cte;
		}

		public void setPackets(List<Packet> packets) {
			this.packets = packets;
		}

		public String toString() {
			return (componentId.getComponentName() + " " + tsiPortId.toString() + " "
					+ ((filter != null) ? filter : "(null)"));// + "\n" + "packets count: " + ((packets != null) ?
																// packets.size() : "(null)"));
		}
	}

	public IotConnectionOffline(Logger log, TriCommunicationTE cte) {
		this.cte = cte;
		this.log = log;
	}

	public synchronized TriStatus triMap(TriPortId comPortId, TriPortId tsiPortId) {
		try {
			boolean result = false;
			log.debug("comPortId.getPortName()= " + comPortId.getPortName() + "; tsiPortId.getPortName()= "
					+ tsiPortId.getPortName());
			// Save parameters for later usage
			// this.comPortId = comPortId;
			// this.tsiPortId = tsiPortId;

			if (tsiPortId.getPortName().equals("acPort")) {
				if (comPortId.getComponent().getComponentName().equals("MTC")) {
					this.comPortId = comPortId;
					this.tsiPortId = tsiPortId;
					ComponentCollection.put(comPortId.getComponent().getComponentName(), tsiPortId);
					ComponentCollectionCompPort.put(comPortId.getComponent().getComponentName(), comPortId);
					// log.debug(""+ComponentCollection.elements().toString());
					// result = connect();
					result = true;
				} else {
					ComponentCollection.put(comPortId.getComponent().getComponentName(), tsiPortId);
					ComponentCollectionCompPort.put(comPortId.getComponent().getComponentName(), comPortId);
					// log.debug(""+ComponentCollection.elements().toString());
					result = true; // assume MTC acport was succesfully conected
				}
			} else if (tsiPortId.getPortName().equals("sipPort")) {
				ComponentCollection.put(comPortId.getComponent().getComponentName() + "-data", tsiPortId);
				ComponentCollectionCompPort.put(comPortId.getComponent().getComponentName()/* +"-sip" */, comPortId);
				// log.debug(""+ComponentCollection.elements().toString());
				result = true; // asuume MTC acport was succesfully conected
			} else if (tsiPortId.getPortName().equals("diameterPort")) {
				ComponentCollection.put(comPortId.getComponent().getComponentName() + "-data", tsiPortId);
				ComponentCollectionCompPort.put(comPortId.getComponent().getComponentName()/* +"-diameter" */,
						comPortId);
				// log.debug(""+ComponentCollection.elements().toString());
				result = true; // asuume MTC acport was succesfully conected
			} else if (tsiPortId.getPortName().equals("dPort")) {
				ComponentCollection.put(comPortId.getComponent().getComponentName() + "-d", tsiPortId);
				ComponentCollectionCompPort.put(comPortId.getComponent().getComponentName() + "-d", comPortId);
				// log.debug(""+ComponentCollection.elements().toString());
				result = true; // asuume MTC acport was succesfully conected
			} else if (tsiPortId.getPortName().equals("")) {
				result = false;
			}

			return (result == true) ? new TriStatusImpl(TriStatus.TRI_OK) : new TriStatusImpl(TriStatus.TRI_ERROR);
			// return new TriStatusImpl(TriStatus.TRI_OK);
		} catch (Throwable ex) {
			ex.printStackTrace();
		}
		return new TriStatusImpl(TriStatus.TRI_ERROR);
	}

	// public synchronized TriStatus triSend(TriAddress triAddress,
	public TriStatus triSend(TriComponentId componentId, TriPortId tsiPortId, TriAddress triAddress,
			TriMessage triMessage) {

		try {
			byte[] buffer = triMessage.getEncodedMessage();

			if (buffer == null) {
				return new TriStatusImpl(TriStatus.TRI_ERROR);
			}
			log.debug("Send message: "/* +triMessage.getClass() +"// " */ + triMessage.toString());

			int recv_reply = 0;
			int iotmsgType = buffer[0] & 0xFF | buffer[1] & 0xFF << 8;
			int iotmsgLen = 2 + 4 + (((buffer[2] & 0xFF)) | ((buffer[3] & 0xFF) << 8) | ((buffer[4] & 0xFF) << 16)
					| ((buffer[5] & 0xFF) << 24));

			switch (iotmsgType) {
			case 7: /* OPEN_DEVICE_REQ = 0x0007; /**< ID of OpenDeviceRequest */
				log.info("ConfigureREQ");
				byte[] confresp = { 0x08, 0x00, 0x01, 0x00, 0x00, 0x00,
						0x00 };/* OPEN_DEVICE_REP = 0x0008; /**< ID of OpenDeviceReply */

				log.debug(this.getTraceFile());

				recv_reply = receiveBuffer(confresp, confresp.length);
				break;

			case 2: /* SET_FILTER_REQ = 0x0002; /**< ID of SetFilterRequest */
				log.info("FilterREQ: " + componentId.getComponentName());
				byte[] filterresp = { 0x09, 0x00, 0x01, 0x00, 0x00, 0x00,
						0x00 };/* SET_FILTER_REP = 0x0009; /**< ID of SetFilterReply */

				String filter = new String(buffer, 10, buffer.length - 10);
				log.debug("FilterREQ: filter=" + filter);
				try {
					FilterPackets fp = new FilterPackets(filter, componentId,
							ComponentCollection.get(componentId.getComponentName() + "-data"), this.cte/* tsiPortId */);
					ComponentCollectionFilter2Port.put(componentId.getComponentName(), fp);
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				FilterMsgFIFO.add(componentId);
				recv_reply = receiveBuffer(filterresp, filterresp.length);
				break;

			case 3:/* START_CAPTURE_REQ = 0x0003; /**< ID of StartCaptureRequest */
				log.info("StartCaptureREQ: " + componentId.getComponentName());
				log.info("StartCaptureREQ: ComponentCollectionFilter2Port=" + ComponentCollectionFilter2Port.size());
				byte[] startcapresp = { 0x04, 0x00, 0x01, 0x00, 0x00, 0x00,
						0x00 };/* START_CAPTURE_REP = 0x0004; /**< ID of StartCaptureReply */

				if (!ComponentCollectionFilter2Port.isEmpty()) {

					Enumeration keys = ComponentCollectionFilter2Port.keys();
					// log.info("StartCaptureREQ: keys=" + keys);

					do {
						try {
							String key = (String) keys.nextElement();
							FilterPackets fp = ComponentCollectionFilter2Port.get(key);
							log.info("StartCaptureREQ: launch ReadCaptureThread for component "
									+ fp.componentId.getComponentName());
							ReadCaptureThread t = new ReadCaptureThread(fp.componentId.getComponentName(), log,
									tracefile, fp);
							t.join(1000);
							Thread.sleep(100);
						} catch (Exception e) {
							log.debug(e.getMessage());
							e.printStackTrace();
						}
					} while (keys.hasMoreElements());
					// adapterCollection.clear();
				}
				
				recv_reply = receiveBuffer(startcapresp, startcapresp.length);
				break;

			case 5:/* STOP_CAPTURE_REQ = 0x0005; /**< ID of StopCaptureRequest */
				log.info("StopCaptureREQ");
				byte[] stopcapresp = { 0x06, 0x00, 0x01, 0x00, 0x00, 0x00,
						0x00 };/* STOP_CAPTURE_REP = 0x0006; /**< ID of StopCaptureReply */

				if (!ComponentCollectionFilter2Port.isEmpty()) {

					Enumeration keys = ComponentCollectionFilter2Port.keys();

					do {
						try {
							String key = (String) keys.nextElement();
							FilterPackets fp = ComponentCollectionFilter2Port.get(key);

							// Check active capture threads
							Thread.sleep(100);

						} catch (Exception e) {
							log.debug(e.getMessage());
						}
					} while (keys.hasMoreElements());
					// adapterCollection.clear();
				}

				recv_reply = receiveBuffer(stopcapresp, stopcapresp.length);
				break;

			default:

			}

//			int packetSize = message.length;
//			byte[] packet = new byte[packetSize];
//			System.arraycopy(message, 0, packet, 0, message.length);
//						
			boolean result = false;
			if (tsiPortId.getPortName().equals("acPort")) {
				if (componentId.getComponentName().equals("MTC")) {
					// result = send(packet);
					result = true;
				} else {
					// for selection sequence to which PTC first send resonse //FILTER_REQ -
					// FILTER_REP
					//log.debug(FilterMsgFIFO.size());
					//FilterMsgFIFO.add(componentId);
					// result = send(packet);
					result = true;
				}
			} else {
				// result = send(packet);
				result = true;
			}

			return (result == true) ? new TriStatusImpl(TriStatus.TRI_OK) : new TriStatusImpl(TriStatus.TRI_ERROR);

		} catch (Throwable ex) {
			log.error("Exception: ", ex);
			System.err.println("Exception: " + ex);
		}
		return new TriStatusImpl(TriStatus.TRI_ERROR);
	}

	public TriStatus triUnmap() {
		return new TriStatusImpl(TriStatus.TRI_OK);
	}

	// public synchronized TriStatus triUnmap() {
	public TriStatus triUnmap(TriPortId comPortId, TriPortId tsiPortId) {
		// log.info("triUnmap");
		try {
			boolean result = true;

			if (tsiPortId.getPortName().equals("acPort")) {
				if (comPortId.getComponent().getComponentName().equals("MTC")) {
					// ComponentCollection.remove(comPortId.getComponent().getComponentName(),
					// tsiPortId);
					result = true;// disconnect();
				} else {
					ComponentCollection.remove(comPortId.getComponent().getComponentName(), tsiPortId);
					ComponentCollectionCompPort.remove(comPortId.getComponent().getComponentName(), comPortId);
					// log.debug(ComponentCollection.elements().toString());
					result = true; // assume MTC acport was successfully connected
				}
			} else if (tsiPortId.getPortName().equals("sipPort")) {
				ComponentCollection.remove(comPortId.getComponent().getComponentName(), tsiPortId);
				ComponentCollectionCompPort.remove(comPortId.getComponent().getComponentName() + "-data", comPortId);
				// log.debug(ComponentCollection.elements().toString());
				result = true; // assume MTC acport was successfully connected
			} else if (tsiPortId.getPortName().equals("diameterPort")) {
				ComponentCollection.remove(comPortId.getComponent().getComponentName(), tsiPortId);
				ComponentCollectionCompPort.remove(comPortId.getComponent().getComponentName() + "-data", comPortId);
				// log.debug(ComponentCollection.elements().toString());
				result = true; // assume MTC acport was successfully connected
			} else if (tsiPortId.getPortName().equals("dPort")) {
				ComponentCollection.remove(comPortId.getComponent().getComponentName(), tsiPortId);
				ComponentCollectionCompPort.remove(comPortId.getComponent().getComponentName() + "-d", comPortId);
				// log.debug(ComponentCollection.elements().toString());
				result = true; // assume MTC acport was successfully connected
			} else {
				result = false;// disconnect();
			}

			return (result == true) ? new TriStatusImpl(TriStatus.TRI_OK) : new TriStatusImpl(TriStatus.TRI_ERROR);

		} catch (Throwable ex) {
			log.error("Exception: ", ex);
		}
		return new TriStatusImpl(TriStatus.TRI_ERROR);
	}

	protected int receiveBuffer(byte[] buffer, int bufferSize) {
		// Try to decode message		
	    Packet ippacket = new Packet();
		
		int packetLength=2+4+(((buffer[2] & 0xFF))|((buffer[3] & 0xFF) << 8)|((buffer[4] & 0xFF) << 16) |  ((buffer[5] & 0xFF)<<24));
		if (bufferSize < packetLength) {
			return 0;
		}
		
		int iotmsg = ((buffer[0] & 0xFF))|((buffer[1] & 0xFF) << 8);//iot message type
		byte[] message = new byte[packetLength];
		log.debug("IOT MSG TYPE "+iotmsg);
		if (iotmsg==1){ //CAPTURE_DATA_IND
			byte[] packetb = new byte[packetLength-0x1b];
			System.arraycopy(buffer,0x1b, packetb, 0, packetLength-0x1b);
			ippacket.data = packetb;
			ippacket.len = packetb.length;
			ippacket.sec = 1;
			// FIXME Set DataLink properly
		    //ippacket = PacketFactory.dataToPacket(1, packetb);
			message = new byte[packetLength-0x45];//SIP or DIAMETER message content
			System.arraycopy(buffer,0x45, message, 0, packetLength-0x45);
		}else{
			System.arraycopy(buffer,0, message, 0, packetLength);
		}
		//base (MTC) component
		TriComponentId compid = this.comPortId.getComponent();
		//for selection sequence to which PTC first send response - //FILTER_MSG_RSP
		if (!FilterMsgFIFO.isEmpty()){ 
			 compid = FilterMsgFIFO.remove();
		}
		
		TriMessage triMessage =TriMessageImpl.valueOf(message);
		TriAddress triAddress = new TriAddressImpl(new byte[] {});

		synchronized(cte) {
			if (iotmsg==1){	//CAPTURE_DATA_IND		
				//DONE in separate class
			}
			else
				log.debug("ENQUE"+tsiPortId.toString()+" "+compid.getComponentName().toString());
			    cte.triEnqueueMsg(tsiPortId, triAddress, compid/*comPortId.getComponent()*/, triMessage);
			
		}
		//Return number of bytes to remove from incoming buffer
		return packetLength;
	}

	public void setTraceFile(String tracefile) {
		this.tracefile = tracefile;
	}

	public String getTraceFile() {
		return this.tracefile;
	}
}
